#include <stdio.h>
#include <assert.h>
#include <set>

using namespace std;

#define MAXN 100000

int sadness(int N, int K, int V[]) {
    multiset<int> s;    // let's use a multiset to store K+1 contiguous elements
    for(int i = 0; i < K; i++) s.insert(V[i]);  // init the multiset with K elements

    int res = 0;
    for(int i = K; i < N; i++) {
        s.insert(V[i]);     // add one more element
        int sad = *s.rbegin() - *s.begin();     // compute sadness (max - min)
        res = max(res, sad);        // possibly, update the maximum
        s.erase(s.find(V[i-K]));    // remove the oldest element
    }
    
    return res;
}


int V[MAXN];

int main() {
    FILE *fr, *fw;
    int N, K, i;

    fr = stdin;//fopen("input.txt", "r");
    fw = stdout;//fopen("output.txt", "w");
    assert(2 == fscanf(fr, "%d %d", &N, &K));
    for(i=0; i<N; i++)
        assert(1 == fscanf(fr, "%d", &V[i]));

    fprintf(fw, "%d\n", sadness(N, K, V));
    fclose(fr);
    fclose(fw);
    return 0;
}
