#include <stdio.h>
#include <assert.h>
#include <set>
#include <climits>

using namespace std;

#define MAXN 100000

int spiana(int N, int K, int A[]) {
    multiset<int> s;    // let's use a multiset to store K contiguous elements
    for(int i = 0; i < K-1; i++) s.insert(A[i]);  // init the multiset with K-1 elements

    int res = INT_MAX;
    for(int i = K-1; i < N; i++) {
        s.insert(A[i]);     // add one more element
        int cost = *s.rbegin() - *s.begin();     // compute cost (max - min)
        res = min(res, cost);         // possibly, update the minimum
        s.erase(s.find(A[i-(K-1)]));  // remove the oldest element
    }
    
    return res;
}


int A[MAXN];

int main() {
    FILE *fr, *fw;
    int N, K, i;

    fr = fopen("input.txt", "r");
    fw = fopen("output.txt", "w");
    assert(2 == fscanf(fr, "%d %d", &N, &K));
    for(i=0; i<N; i++)
        assert(1 == fscanf(fr, "%d", &A[i]));

    fprintf(fw, "%d\n", spiana(N, K, A));
    fclose(fr);
    fclose(fw);
    return 0;
}
